<?php
##################################
# all export functions
##################################

// check forbidden characters for XML
function convertXML($str) {
   if (!strstr($str,"&")) return $str;
				    else   return "<![CDATA[$str]]>";		
}

function convertXMLLink($str) {
			return str_replace("&","&amp;",$str);		
}


// generate a HTML page with all links
function exportHTML($idFolder, $spacer) { 
   // list site
   $query = "SELECT site_name, site_desc, site_url
	     		FROM  wiklink_site 
		  		WHERE site_folder = '$idFolder' 
				ORDER BY site_name ASC";		  
       $result = execQuery($query);
       while ($pt = nextLine($result)) {	      	   
		   echo "<li>";
	       generateA($pt->site_name, $pt->site_url , addslashes($pt->site_desc));
		   echo  "</li>\n";	      
	}
	
	// list folder recursive
   	$query = "SELECT folder_id, folder_name 
	        FROM  wiklink_folder 
			WHERE folder_parent = '$idFolder'
			ORDER BY folder_name ASC";						   
	$result = execQuery($query);
	while ($pt = nextLine($result)) {	   
	   echo  "<li><ul>\n<li><h2>$pt->folder_name</h2></li>\n";	   	 	   	  	   
	   exportHTML($pt->folder_id, $spacer);	   
	   echo "</ul></li>\n"; 	    
	} 	  
} 
 
// backup base in XML ** DEPRECATED use xlink **
function exportXML($idFolder) {
	// list site
   $query = "SELECT site_name, site_desc, site_url
	     		FROM  wiklink_site 
		  		WHERE site_folder = '$idFolder' 
				ORDER BY site_name ASC";		  
       $result = execQuery($query);
       while ($pt = nextLine($result)) {
	        echo "<site>";
			echo "<name>".convertXML($pt->site_name)."</name>";
			echo "<url>".convertXML($pt->site_url)."</url>"; 
			echo "<desc>".convertXML($pt->site_desc)."</desc>";			
			echo "</site>";
	   } 
	// list folder recursive
   	$query = "SELECT folder_id, folder_name , folder_desc 
	        FROM  wiklink_folder 
			WHERE folder_parent = '$idFolder'
			ORDER BY folder_name ASC";						   
	$result = execQuery($query);
	while ($pt = nextLine($result)) {	   
	    echo "<folder>";		
		echo "<fname>".convertXML($pt->folder_name)."</fname>";		
		echo "<fdesc>".convertXML($pt->folder_desc)."</fdesc>";		
		exportXML($pt->folder_id);
		echo "</folder>"; 
	} 
} 

// backup base in XLink
function exportXMLLink($idFolder) {
	// list site
   $query = "SELECT site_name, site_desc, site_url
	     		FROM  wiklink_site 
		  		WHERE site_folder = '$idFolder' 
				ORDER BY site_name ASC";		  
       $result = execQuery($query);
	   $str = '';
       while ($pt = nextLine($result)) {
	        $str .= "<site xlink:type=\"simple\" ";
			$str .= " xlink:href=\"".convertXMLLink($pt->site_url)."\"";
			$str .= " xlink:title=\"".convertXMLLink($pt->site_desc)."\" >";
			$str .= convertXML($pt->site_name)."</site>";
	   } 
	   echo $str;
	// list folder recursive
   	$query = "SELECT folder_id, folder_name , folder_desc 
	        FROM  wiklink_folder 
			WHERE folder_parent = '$idFolder'
			ORDER BY folder_name ASC";						   
	$result = execQuery($query);	
	while ($pt = nextLine($result)) {		
		// xlink help needed:
		// for folder, we could use xlink:type="extended" and links located in this category type="locator"
		// in this case, we must split extended node and  locator node (instead of using of folded structure)
		// the main problem, xlink exclude extended included in anothed extented
		// any help, comments are very welcome....
		echo "<folder>";		
		echo "<fname>".convertXML($pt->folder_name)."</fname>";		
		echo "<fdesc>".convertXML($pt->folder_desc)."</fdesc>";		
		exportXMLLink($pt->folder_id);
		echo "</folder>"; 
	} 
} 
   
// backup netscape
function exportNetscape($idFolder, $indent) { 
   global $eol;
   $spacer = "   "; 
   
   // list site
   $query = "SELECT site_name, site_modify, site_desc, site_url
	     		FROM  wiklink_site 
		  		WHERE site_folder = '$idFolder' 
				ORDER BY site_name ASC";		  
       $result = execQuery($query);
       while ($pt = nextLine($result)) {
	       for ($j = 0; $j < $indent; $j++) echo $spacer;		   
		   $unix = mktime(0,0,0, substr($pt->site_modify,4,2),  substr($pt->site_modify,6,2),  substr($pt->site_modify,0,4));     	     
	       echo "<DT><A HREF=\"$pt->site_url\" ADD_DATE=\"$unix\" LAST_VISIT=\"$unix\" LAST_MODIFIED=\"$unix\">$pt->site_name</A>$eol";	       
		   
	} 
      
   // folder 
   	$query = "SELECT folder_id, folder_name, folder_modify 
	        FROM  wiklink_folder 
			WHERE folder_parent = '$idFolder'
			ORDER BY folder_name ASC";						   
	$result = execQuery($query);
	while ($pt = nextLine($result)) {
	   for ($j = 0; $j < $indent; $j++) echo $spacer;
	   $unix = mktime(0,0,0, substr($pt->folder_modify,4,2),  substr($pt->folder_modify,6,2),  substr($pt->folder_modify,0,4));  	  	   
	   echo "<DT><H3 FOLDED ADD_DATE=\"$unix\">$pt->folder_name</H3>$eol"; 
	   for ($j = 0; $j < $indent; $j++) echo $spacer; 
	   echo "<DL><p>$eol";  
	   exportNetscape($pt->folder_id, $indent+1);
	   for ($j = 0; $j < $indent; $j++) echo $spacer; 
	   echo "</DL><p>$eol";	 
	}	
} 


// download 
function downLoadHeader($filename) {
  header("Content-disposition: attachment; filename=\"$filename\" ");
  header("Content-type: application/octetstream");
  header("Pragma: no-cache");
  header("Expires: 0");
}

function generateTopExport() {
	echo "<?xml version=\"1.0\" encoding=\"".WIK_CHARSET."\"?".">\n"; 
	echo "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n";
	echo "<html xmlns=\"http://www.w3.org/1999/xhtml\">\n\n";
	echo "<head>\n";
	echo "  <title>".PAGE_TITLE."</title>\n";
	echo "  <meta http-equiv=\"Content-Type\" content=\"text/html; charset=".WIK_CHARSET."\" />\n";
	echo "  <style type=\"text/css\">\n";
	echo "  body {font-family:Arial, Verdana, sans-serif;}\n";
	echo "  li {list-style-type: none;}\n";
	echo "  </style>\n";
	echo "</head>\n\n";
	echo "<body>\n";
	echo "<h1>".PAGE_TITLE."</h1>\n";
	echo "<ul>\n";
}


function generateBottomExport() {
	echo "</ul>\n";
	echo "<div style=\"font-family:Verdana, sans-serif;font-size:9px;border-top: 1px solid #333;\">\n";
	echo "generated by <a href=\"http://www.erational.org/software/wiklink\">WikLink/".WIKLINK_VERSION."</a> - ";
	echo date("F j, Y, g:i a")."</div>\n";               
	echo "</body>\n";
	echo "</html>\n";
}
 	
?>
