<?php
# inspired by from bookmark4u
# check if string $url is a valid URL address
# return 1 if the url is valid, return 0 if not valid
# reporting message is returned in the $msg
# contributed by Eric Meddaugh
# modified by erational


function TimeStampUsec() {
  $now =  gettimeofday();
  $usec = $now['sec'] * 1000000 + $now['usec'];
  return $usec;
}

function linkAlive($url, &$msg) {
  $msg = "";
  $tmpmsg = "";
  # parse url string
  $url_arr = parse_url($url);

  $server = $url_arr['host'];     # server host
  if  (isset($url_arr['part'])) { # path
  	$path = $url_arr['path'];    
  }	else {
  	$path = "/";
  }
  if (isset($url_arr['port'])) { # port number
    $port = $url_arr['port'];
  }
  # known protocol port numbers
  else if ($url_arr['scheme'] == 'http')   $port = 80;
  else if ($url_arr['scheme'] == 'ftp')    $port = 21;
  else if ($url_arr['scheme'] == 'https')  $port = 443;
  else if ($url_arr['scheme'] == 'news')   $port = 119;
  else if ($url_arr['scheme'] == 'telnet') $port = 23;
  
  $time1 = TimeStampUsec(); # start checking time
  $timeout = 2;   
  $fp = @fsockopen($server, $port, $errno, $errstr, $timeout);
  if (!$fp) {
    $time2 = TimeStampUsec();
    $diff =(int) (($time2 - $time1) / 1000);
	$o = $url_arr['host'];
    $msg .= " ($diff ms) ";
    return 0; # link is *not* valid
  } else {
    
    // HTTP 
    if ($url_arr['scheme'] == 'http') {
      fputs ($fp, "HEAD http://$server$path HTTP/1.0\r\n\r\n");
      while (!feof($fp)) {
        $line = fgets($fp, 128);
        $tmpmsg .= $line;
      }    
    fclose ($fp);
    $tmpmsg = strip_tags($tmpmsg);
    $tmp_arr = preg_split("/ /", $tmpmsg);
	
    # Need to try again for other vhosts....
    if ($tmp_arr[1] == 400 || $tmp_arr[1] == 404 || $tmp_arr[1] == 403) { 
      $tmpmsg = "";
      $fp = fsockopen($server, $port, $errno, $errstr, $timeout);
      fputs ($fp, "HEAD $path HTTP/1.0\r\nHost: $server\r\n\r\n");
      while (!feof($fp)) {
        $line = fgets($fp, 128);
        $tmpmsg .= $line;
      }
      fclose($fp);
      $tmpmsg = strip_tags($tmpmsg);
      $tmp_arr = preg_split("/ /", $tmpmsg);
    }

    if ($tmp_arr[1] == 200) { $msg .= "Valid"; }
    elseif ($tmp_arr[1] == 404) { $msg .= "404 NOT FOUND"; }
    elseif ($tmp_arr[1] == 301) { $msg .= "301 MOVED PERMANENTLY"; }
    elseif ($tmp_arr[1] == 302) { $msg .= "302 MOVED TEMPORARILY"; }
    elseif ($tmp_arr[1] == 401) { $msg .= "401 UNAUTHORIZED"; }
    elseif ($tmp_arr[1] == 403) { $msg .= "403 FORBIDDEN"; }
	elseif ($tmp_arr[1] == 400) { $msg .= "400 BAD REQUEST"; }
    elseif ($tmp_arr[1] == 500) { $msg .= "500 INTERNAL SERVER ERROR"; }
    elseif ($tmp_arr[1] == 501) { $msg .= "501 NOT IMPLEMENTED"; }
    elseif ($tmp_arr[1] == 503) { $msg .= "503 SERVICE UNAVAILABLE"; }
	  else { $msg .= "UNKNOWN TYPE ".$tmp_arr[1]; }
    } else {
	// other protocols !HTTP
	$msg .= "Valid"; // correct ?
	}
    $time2 = TimeStampUsec();
    $diff = (int)(($time2 - $time1) / 1000);
    $msg .= " ($diff ms)";
    return 1; # link is valid
  }
}	
?>