<?php
//// ----------------------------------
// class based on SAX to parse XML document
// thx to rigaux
//// ----------------------------------

class SAX 
{
  var $parser;
  var $data; 
  var $errorOccurs; 

// class constructor
function SAX ()  
 {

   $this->parser = xml_parser_create();
   xml_set_object($this->parser, $this); //&$this

   xml_parser_set_option($this->parser, XML_OPTION_CASE_FOLDING, true);

   xml_set_element_handler ($this->parser, "elementOpen", "elementEnd");
   xml_set_character_data_handler ($this->parser, "dataCaracteres");

   $this->errorOccurs = 0;
 }

// Open Tags  Analysis
function elementOpen ($parser, $name, $attrs)
{
  if (method_exists ($this, "open$name"))
    @call_user_method("open$name", $this, $parser, $name, $attrs);
   else if (get_class($this) == "sax")
    echo "open tag : &lt;" . $name . "&gt;\n";

  $this->data = "";
}

// End Tags  Analysis
function elementEnd ($parser, $name)
{
  if (method_exists ($this, "end$name"))
    @call_user_method("end$name", $this, $parser, $name);
   else if (get_class($this) == "sax")
       echo "end tag : &lt;/" . $name . "&gt;\n";
}

function dataCaracteres ($parser, $str)
{
  if (!empty($str))  $this->data .= $str;
}

// file parsing
function parse($file) 
{
  if ( !($f = fopen($file, "r"))) 
  {
    $this->error("Can't open the file $file\n");
    return;
  } 

  while ($data = fread($f, 4096)) 
  {
    if (!xml_parse($this->parser, $data, feof($f)))
     {
        $this->error("Error occurs line " 
            . xml_error_string(xml_get_error_code($this->parser))
            . "%from $file : "
            . xml_get_current_line_number($this->parser));
        return;
     }
  }
  fclose ($f);
}

function end() 
{
  xml_parser_free($this->parser); 
}

function error($msg)
{
    echo "<b>$msg</b>\n";
    $this->errorOccurs = 1;
}

}
?>