<?php
// generate a syndication file
// rss v1.00
header("Content-type: application/xml");

// no cache
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");              
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");   
header("Cache-Control: no-cache, must-revalidate");           // HTTP/1.1  
header("Pragma: no-cache");                                   // HTTP/1.0

require_once("./lib/inc_globals.php");
require_once("./lib/inc_sql.php");
require_once("./lib/inc_loadpreference.php");

// check forbidden characters for XML
function convertXML($str) {
    if (!strstr($str,"&")) return $str;
				    else   return "<![CDATA[$str]]>";
}


$connection = wiklink_connect(USERNAME,PASSWORD,HOSTNAME,DATABASE);

$wiklink_uri = "http://".getenv('HTTP_HOST').$_SERVER['PHP_SELF'];
$wiklink_uri = ereg_replace('rss.php', '', $wiklink_uri);

echo "<?xml version=\"1.0\" encoding=\"".WIK_CHARSET."\"?>";
echo "<rdf:RDF xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\" xmlns:sy=\"http://purl.org/rss/1.0/modules/syndication/\"
 xmlns=\"http://purl.org/rss/1.0/\" >";
echo "<channel rdf:about=\"".$wiklink_uri."rss.php\">";
echo "<title>".convertXML(PAGE_TITLE)."</title>"; 
echo "<description>".convertXML(WIK_DESCRIPTION)."</description>";
echo "<sy:updatePeriod>hourly</sy:updatePeriod>";
echo "<sy:updateFrequency>1</sy:updateFrequency>";
echo "<sy:updateBase>2005-01-01T12:00+00:00</sy:updateBase>";
echo "<link>".convertXML($wiklink_uri)."</link>";
echo "<textinput rdf:resource=\"".$wiklink_uri."search.php\" />";
echo "<items>";
echo "<rdf:Seq>";

// find data 
$query = "SELECT  site_id, site_name, site_modify , site_folder, site_url, site_desc
								FROM  wiklink_site
		  				 		ORDER BY site_modify DESC
		  				 		LIMIT 15";
$result = execQuery($query);
$c = 0;
while ($pt = nextLine($result)) {
	//echo "<li rdf:resource=\"".$wiklink_uri."index.php?folder=".$pt->site_folder."&amp;foo=$c\" />";
	echo "<rdf:li resource=\"".$wiklink_uri."index.php?folder=".$pt->site_folder."&amp;foo=$c\" />";
	$c++;
}
echo "</rdf:Seq>";
echo "</items>";
echo "</channel>";

// item
$result = execQuery($query);
$c = 0;
while ($pt = nextLine($result)) {
			echo "<item rdf:about=\"".$wiklink_uri."index.php?folder=".$pt->site_folder."&amp;foo=$c\">";
			echo "<title>".convertXML($pt->site_name)."</title>";
			echo "<description>".convertXML($pt->site_desc)."</description>";
			echo "<link>".convertXML($pt->site_url)."</link>";
			echo "</item>";
			$c++;
}
echo "<textinput rdf:about=\"".$wiklink_uri."search.php\">";
echo "<title>Search ".PAGE_TITLE."</title>"; 
echo "<description>Search ".PAGE_TITLE."</description>"; 
echo "<name>query</name>"; 
echo "<link>".$wiklink_uri."search.php</link>";
echo "</textinput>";
echo "</rdf:RDF>";
?>